Add host art from a master build

Bug: b/242548283
Change-Id: I190563fdfc78b964f8281d51b5e9dcb9f0fc98b5
diff --git a/.gitignore b/.gitignore
index ada4839..ae1be52 100644
--- a/.gitignore
+++ b/.gitignore
@@ -276,6 +276,8 @@
 tools/*/host/art-12.0.0-beta4.tar.gz
 tools/*/host/art-13-dev
 tools/*/host/art-13-dev.tar.gz
+tools/*/host/art-master
+tools/*/host/art-master.tar.gz
 tools/*/art.tar.gz
 tools/*/dalvik
 tools/*/dalvik-4.0.4
diff --git a/build.gradle b/build.gradle
index f63df38..ce306b1 100644
--- a/build.gradle
+++ b/build.gradle
@@ -411,6 +411,7 @@
                 "linux/art-10.0.0",
                 "linux/host/art-12.0.0-beta4",
                 "linux/host/art-13-dev",
+                "linux/host/art-master",
                 "linux/dalvik",
                 "linux/dalvik-4.0.4",
                 "${osString}/dx",
diff --git a/scripts/update-host-art.sh b/scripts/update-host-art.sh
index 58165cd..44e5a49 100755
--- a/scripts/update-host-art.sh
+++ b/scripts/update-host-art.sh
@@ -91,9 +91,24 @@
 ANDROID_TARGET_BUILD=$ANDROID_CHECKOUT/out/target
 DEST=$DEST_ROOT/$ART_DIR
 
-# Clean out the previous version of Art
+# Clean out the previous version of Art.
 rm -rf $DEST
 
+# Copy build_spec.xml for documentation.
+mkdir -p $DEST
+if [ -f $ANDROID_CHECKOUT/build_spec.xml ]; then
+  cp $ANDROID_CHECKOUT/build_spec.xml $DEST
+  # Remove the build spec to ensure it is created anew for a new build.
+  rm $ANDROID_CHECKOUT/build_spec.xml
+else
+  echo "File $ANDROID_CHECKOUT/build_spec.xml not found. Please run"
+  echo
+  echo "  repo manifest -r -o build_spec.xml"
+  echo
+  echo "in $ANDROID_CHECKOUT"
+  exit 1
+fi
+
 # Required binaries and scripts.
 mkdir -p $DEST/bin
 if [ -f $ANDROID_HOST_BUILD/bin/art ]; then
diff --git a/tools/linux/README.art-versions b/tools/linux/README.art-versions
index 02e81cd..94d78e1 100644
--- a/tools/linux/README.art-versions
+++ b/tools/linux/README.art-versions
@@ -42,6 +42,29 @@
   <continue with repo sync as above>
 
 
+art-master (Currently Android U)
+--------------------------------
+Build from master, build spec included. Art at 31b98e9ce8fbb56c3507c8e7718881efa1ce9f63.
+
+repo sync -cq -j24
+source build/envsetup.sh
+lunch aosp_redfin-userdebug
+m -j48
+m -j48 build-art
+m -j48 test-art-host
+repo manifest -r -o build_spec.xml
+
+Collected into tools/linux/host/art-master. The "host" path element is checked
+by the script for running Art.
+
+  cd <r8 checkout>
+  scripts/update-host-art.sh \
+     --android-checkout <...>/android/tm-dev \
+     --art-dir host/art-master \
+     --android-product redfin
+
+(cd tools/linux/host; upload_to_google_storage.py -a --bucket r8-deps art-master)
+
 art-13 (Android T)
 ------------------
 Build from tm-dev commit 442e1091f39417c692d91609af05e58af60d8e2b.
diff --git a/tools/linux/host/art-master.tar.gz.sha1 b/tools/linux/host/art-master.tar.gz.sha1
new file mode 100644
index 0000000..096aa8c
--- /dev/null
+++ b/tools/linux/host/art-master.tar.gz.sha1
@@ -0,0 +1 @@
+7c795b752ba1edce6c3e9e11d837d31eb78043a3
\ No newline at end of file